#ifndef LogH
#define LogH
#include <string>
#include "singleton.h"

enum E_LOGLEVEL
{
	E_LOG_NONE = 0,
	E_LOG_TRACE,
	E_LOG_ALL
};

class CLog: public CSingleton<CLog>
{
public:
	void log(int level, char *lpData, ...);
	int SetFile(std::string);
	void SetLevel(int);
	typedef void (__closure *CallbackLog)(char *buf);
	CallbackLog callbackLog;
private:
	CLog();
	//~CLog() {};
	friend CSingleton<CLog>;
	std::string sFile;
	int iLogLevel;
};

#define LOG CLog::Instance()->log

#endif
