//---------------------------------------------------------------------------


#pragma hdrstop

#include "ValueStringFormatter.h"
#include <SysUtils.hpp>
#include <math.h>

//---------------------------------------------------------------------------

#pragma package(smart_init)

std::string ValueStringFormatter::VoltageToStr(float val, int precision)
{
	std::string sUnit = "V";
	if (fabs(val) < 0.1f)
	{
		val *= 1000;
		sUnit = "mV";
	}
	if (precision <= 2)
	{
		return (std::string)(FloatToStrF(val,ffFixed , 4, 1).c_str()) + sUnit;
	}
	else
	{
		return (std::string)(FloatToStrF(val,ffFixed , 4, 2).c_str()) + sUnit;
	}
}

std::string ValueStringFormatter::TimeToStr(float val, int precision)
{
	std::string sUnit;
	if (fabs(val) < 0.1e-3f)
	{
		val *= 1.0e6f;
		sUnit = "us";
	}
	else if (fabs(val) < 0.1f)
	{
		val *= 1000;
		sUnit = "ms";
	}
	else
	{
		sUnit = "s";
	}
	if (precision <= 2)
	{
		return (std::string)(FloatToStrF(val,ffFixed , 4, 1).c_str()) + sUnit;
	}
	else
	{
		return (std::string)(FloatToStrF(val,ffFixed , 4, 2).c_str()) + sUnit;
	}
}

std::string ValueStringFormatter::FreqToStr(float val, int precision)
{
	std::string sUnit;
	if (fabs(val)>1000)
	{
		val /=1000;
		sUnit = "kHz";
	}
	else
	{
		sUnit = "Hz";
	}
	if (precision <= 2)
	{
		//
		return (std::string(FloatToStrF(val,ffFixed , 3, 1).c_str())+sUnit);
	}
	else
	{
		return (std::string(FloatToStrF(val,ffFixed , 4, 3).c_str())+sUnit);		
	}
}
